From 3fc17c05dc5dc1aa8c48f693b267a562332a6ee6 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Mon, 10 Jun 2019 13:54:50 +0200
Subject: [PATCH 2/2] Adjust README.DELETED.

---
 contrib/wpa_supplicant/README.DELETED | 264 +++++++++++++++++++++++++-
 1 file changed, 263 insertions(+), 1 deletion(-)

diff --git a/contrib/wpa_supplicant/README.DELETED b/contrib/wpa_supplicant/README.DELETED
index 7e01475d2b..a62ed42d1e 100644
--- a/contrib/wpa_supplicant/README.DELETED
+++ b/contrib/wpa_supplicant/README.DELETED
@@ -1,50 +1,312 @@
+COPYING
+README
+patches/
 src/Makefile
 src/ap/Makefile
+src/ap/accounting.c
+src/ap/accounting.h
+src/ap/acs.c
+src/ap/acs.h
+src/ap/ap_config.c
+src/ap/ap_drv_ops.c
+src/ap/ap_drv_ops.h
+src/ap/ap_list.c
+src/ap/ap_list.h
+src/ap/ap_mlme.c
+src/ap/ap_mlme.h
+src/ap/authsrv.c
+src/ap/authsrv.h
+src/ap/beacon.c
+src/ap/beacon.h
+src/ap/ctrl_iface_ap.c
+src/ap/ctrl_iface_ap.h
+src/ap/dfs.c
+src/ap/dfs.h
+src/ap/drv_callbacks.c
+src/ap/eap_user_db.c
+src/ap/gas_serv.c
+src/ap/gas_serv.h
+src/ap/hostapd.c
+src/ap/hw_features.c
+src/ap/hw_features.h
+src/ap/iapp.c
+src/ap/iapp.h
+src/ap/ieee802_11.c
+src/ap/ieee802_11.h
+src/ap/ieee802_11_auth.c
+src/ap/ieee802_11_auth.h
+src/ap/ieee802_11_ht.c
+src/ap/ieee802_11_shared.c
+src/ap/ieee802_11_vht.c
+src/ap/ieee802_1x.c
+src/ap/ieee802_1x.h
+src/ap/p2p_hostapd.c
+src/ap/p2p_hostapd.h
+src/ap/peerkey_auth.c
+src/ap/pmksa_cache_auth.c
+src/ap/pmksa_cache_auth.h
+src/ap/preauth_auth.c
+src/ap/preauth_auth.h
+src/ap/sta_info.c
+src/ap/sta_info.h
+src/ap/tkip_countermeasures.c
+src/ap/tkip_countermeasures.h
+src/ap/utils.c
+src/ap/vlan_init.c
+src/ap/vlan_init.h
+src/ap/vlan_util.c
+src/ap/vlan_util.h
+src/ap/wmm.c
+src/ap/wmm.h
+src/ap/wnm_ap.c
+src/ap/wnm_ap.h
+src/ap/wpa_auth.c
+src/ap/wpa_auth.h
+src/ap/wpa_auth_ft.c
+src/ap/wpa_auth_glue.c
+src/ap/wpa_auth_glue.h
+src/ap/wpa_auth_i.h
+src/ap/wpa_auth_ie.c
+src/ap/wpa_auth_ie.h
+src/ap/wps_hostapd.c
+src/ap/wps_hostapd.h
 src/common/Makefile
+src/common/privsep_commands.h
+src/common/qca-vendor.h
+src/common/sae.c
 src/crypto/.gitignore
 src/crypto/Makefile
+src/crypto/aes-ccm.c
+src/crypto/aes-gcm.c
+src/crypto/aes-wrap.c
+src/crypto/crypto_cryptoapi.c
+src/crypto/crypto_gnutls.c
+src/crypto/crypto_internal.c
+src/crypto/crypto_libtomcrypt.c
+src/crypto/crypto_none.c
+src/crypto/crypto_nss.c
+src/crypto/fips_prf_cryptoapi.c
+src/crypto/fips_prf_gnutls.c
+src/crypto/fips_prf_nss.c
+src/crypto/milenage.c
+src/crypto/sha1-tprf.c
+src/crypto/sha256-tlsprf.c
+src/crypto/tls_gnutls.c
+src/crypto/tls_none.c
+src/crypto/tls_nss.c
+src/crypto/tls_schannel.c
 src/drivers/.gitignore
 src/drivers/Makefile
+src/drivers/android_drv.h
+src/drivers/driver_atheros.c
+src/drivers/driver_hostap.c
+src/drivers/driver_hostap.h
+src/drivers/driver_madwifi.c
+src/drivers/driver_ndis_.c
+src/drivers/driver_nl80211.c
+src/drivers/driver_none.c
+src/drivers/driver_openbsd.c
+src/drivers/driver_privsep.c
+src/drivers/driver_roboswitch.c
+src/drivers/driver_test.c
+src/drivers/driver_wext.c
+src/drivers/driver_wext.h
 src/drivers/drivers.mak
 src/drivers/drivers.mk
+src/drivers/linux_ioctl.c
+src/drivers/linux_ioctl.h
+src/drivers/linux_wext.h
+src/drivers/netlink.c
+src/drivers/netlink.h
+src/drivers/nl80211_copy.h
+src/drivers/priv_netlink.h
+src/drivers/rfkill.c
+src/drivers/rfkill.h
 src/eap_common/Makefile
+src/eap_common/eap_eke_common.c
+src/eap_common/eap_eke_common.h
+src/eap_common/eap_fast_common.c
+src/eap_common/eap_ikev2_common.c
+src/eap_common/eap_ikev2_common.h
+src/eap_common/eap_pwd_common.c
+src/eap_common/eap_pwd_common.h
+src/eap_common/eap_wsc_common.c
+src/eap_common/ikev2_common.c
 src/eap_peer/Makefile
+src/eap_peer/eap_eke.c
+src/eap_peer/eap_fast.c
+src/eap_peer/eap_fast_pac.c
+src/eap_peer/eap_fast_pac.h
+src/eap_peer/eap_ikev2.c
+src/eap_peer/eap_proxy_dummy.c
+src/eap_peer/eap_pwd.c
+src/eap_peer/eap_tnc.c
+src/eap_peer/eap_vendor_test.c
+src/eap_peer/eap_wsc.c
+src/eap_peer/ikev2.c
+src/eap_peer/ikev2.h
+src/eap_peer/tncc.c
 src/eap_server/Makefile
+src/eap_server/eap_server.c
+src/eap_server/eap_server_aka.c
+src/eap_server/eap_server_eke.c
+src/eap_server/eap_server_fast.c
+src/eap_server/eap_server_gpsk.c
+src/eap_server/eap_server_gtc.c
+src/eap_server/eap_server_identity.c
+src/eap_server/eap_server_ikev2.c
+src/eap_server/eap_server_md5.c
+src/eap_server/eap_server_methods.c
+src/eap_server/eap_server_mschapv2.c
+src/eap_server/eap_server_pax.c
+src/eap_server/eap_server_peap.c
+src/eap_server/eap_server_psk.c
+src/eap_server/eap_server_pwd.c
+src/eap_server/eap_server_sake.c
+src/eap_server/eap_server_sim.c
+src/eap_server/eap_server_tls.c
+src/eap_server/eap_server_tls_common.c
+src/eap_server/eap_server_tnc.c
+src/eap_server/eap_server_ttls.c
+src/eap_server/eap_server_vendor_test.c
+src/eap_server/eap_server_wsc.c
+src/eap_server/eap_sim_db.c
+src/eap_server/eap_sim_db.h
+src/eap_server/ikev2.c
+src/eap_server/ikev2.h
+src/eap_server/tncs.c
+src/eap_server/tncs.h
 src/eapol_auth/Makefile
+src/eapol_auth/eapol_auth_dump.c
+src/eapol_auth/eapol_auth_sm.c
+src/eapol_auth/eapol_auth_sm.h
+src/eapol_auth/eapol_auth_sm_i.h
 src/eapol_supp/Makefile
 src/l2_packet/Makefile
+src/l2_packet/l2_packet_freebsd.c
+src/l2_packet/l2_packet_linux.c
+src/l2_packet/l2_packet_ndis.c
+src/l2_packet/l2_packet_none.c
+src/l2_packet/l2_packet_pcap.c
+src/l2_packet/l2_packet_privsep.c
+src/l2_packet/l2_packet_winpcap.c
 src/lib.rules
 src/p2p/Makefile
+src/p2p/p2p.c
+src/p2p/p2p_build.c
+src/p2p/p2p_dev_disc.c
+src/p2p/p2p_go_neg.c
+src/p2p/p2p_group.c
+src/p2p/p2p_i.h
+src/p2p/p2p_invitation.c
+src/p2p/p2p_parse.c
+src/p2p/p2p_pd.c
+src/p2p/p2p_sd.c
+src/p2p/p2p_utils.c
 src/radius/.gitignore
 src/radius/Makefile
+src/radius/radius.c
+src/radius/radius_client.c
+src/radius/radius_client.h
+src/radius/radius_das.c
+src/radius/radius_das.h
+src/radius/radius_server.c
+src/radius/radius_server.h
 src/rsn_supp/Makefile
+src/rsn_supp/tdls.c
 src/tls/.gitignore
 src/tls/Makefile
+src/tls/libtommath.c
+src/tls/tlsv1_server.c
+src/tls/tlsv1_server_i.h
+src/tls/tlsv1_server_read.c
+src/tls/tlsv1_server_write.c
 src/utils/.gitignore
 src/utils/Makefile
+src/utils/bitfield.c
+src/utils/bitfield.h
+src/utils/edit_readline.c
+src/utils/edit_simple.c
+src/utils/eloop_win.c
+src/utils/ext_password.c
+src/utils/ext_password_i.h
+src/utils/ext_password_test.c
+src/utils/ip_addr.c
+src/utils/os_internal.c
+src/utils/os_none.c
+src/utils/os_win32.c
+src/utils/radiotap.c
+src/utils/radiotap_iter.h
+src/utils/trace.c
 src/wps/Makefile
+src/wps/ndef.c
+src/wps/wps_er.c
+src/wps/wps_er.h
+src/wps/wps_er_ssdp.c
+src/wps/wps_validate.c
 wpa_supplicant/.gitignore
 wpa_supplicant/Android.mk
 wpa_supplicant/Makefile
 wpa_supplicant/README-Windows.txt
 wpa_supplicant/android.config
+wpa_supplicant/ap.c
+wpa_supplicant/autoscan.c
+wpa_supplicant/autoscan_exponential.c
+wpa_supplicant/autoscan_periodic.c
+wpa_supplicant/bgscan.c
+wpa_supplicant/bgscan_learn.c
+wpa_supplicant/bgscan_simple.c
+wpa_supplicant/config_none.c
+wpa_supplicant/config_winreg.c
+wpa_supplicant/ctrl_iface_named_pipe.c
+wpa_supplicant/ctrl_iface_udp.c
 wpa_supplicant/dbus/.gitignore
 wpa_supplicant/dbus/Makefile
 wpa_supplicant/dbus/dbus-wpa_supplicant.conf
+wpa_supplicant/dbus/dbus_common.c
+wpa_supplicant/dbus/dbus_common_i.h
+wpa_supplicant/dbus/dbus_dict_helpers.c
+wpa_supplicant/dbus/dbus_dict_helpers.h
+wpa_supplicant/dbus/dbus_new.c
+wpa_supplicant/dbus/dbus_new_handlers.c
+wpa_supplicant/dbus/dbus_new_handlers.h
+wpa_supplicant/dbus/dbus_new_handlers_p2p.c
+wpa_supplicant/dbus/dbus_new_handlers_p2p.h
+wpa_supplicant/dbus/dbus_new_handlers_wps.c
+wpa_supplicant/dbus/dbus_new_helpers.c
+wpa_supplicant/dbus/dbus_new_helpers.h
+wpa_supplicant/dbus/dbus_new_introspect.c
+wpa_supplicant/dbus/dbus_old.c
+wpa_supplicant/dbus/dbus_old_handlers.c
+wpa_supplicant/dbus/dbus_old_handlers.h
+wpa_supplicant/dbus/dbus_old_handlers_wps.c
 wpa_supplicant/dbus/fi.epitest.hostap.WPASupplicant.service.in
 wpa_supplicant/dbus/fi.w1.wpa_supplicant1.service.in
 wpa_supplicant/defconfig
 wpa_supplicant/doc/
 wpa_supplicant/eap_proxy_dummy.mk
+wpa_supplicant/eapol_test.c
 wpa_supplicant/examples/
+wpa_supplicant/ibss_rsn.c
+wpa_supplicant/main_none.c
+wpa_supplicant/main_winmain.c
+wpa_supplicant/main_winsvc.c
+wpa_supplicant/nfc_pw_token.c
 wpa_supplicant/nmake.mak
+wpa_supplicant/p2p_supplicant.c
+wpa_supplicant/preauth_test.c
+wpa_supplicant/sme.c
 wpa_supplicant/systemd/
 wpa_supplicant/tests/
 wpa_supplicant/todo.txt
-wpa_supplicant/utils/log2pcap.py
+wpa_supplicant/utils/
 wpa_supplicant/vs2005/
+wpa_supplicant/wifi_display.c
 wpa_supplicant/win_example.reg
+wpa_supplicant/win_if_list.c
+wpa_supplicant/wnm_sta.c
 wpa_supplicant/wpa_gui-qt4/
+wpa_supplicant/wpa_priv.c
 wpa_supplicant/wpa_supplicant.conf
 wpa_supplicant/wpa_supplicant_conf.mk
 wpa_supplicant/wpa_supplicant_conf.sh
-- 
2.26.1